## original-awk 2025-08

=== Makefile ===
# Makefile for GNU Awk test suite.
#
# Copyright (C) 1988-1997 the Free Software Foundation, Inc.
#
# This file is part of GAWK, the GNU implementation of the
# AWK Programming Language.
#
# GAWK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# GAWK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

SHELL = /bin/sh
AWK = ../gawk
AWK = awk
AWK = ../../a.out
CMP = cmp

srcdir = @srcdir@
srcdir = .
VPATH = @srcdir@
VPATH = $(srcdir)

all:	bigtest

# bigtest:	basic unix-tests gawk.extensions
bigtest:	basic unix-tests

# Tests in alphabetical order for progress feedback:
#
# Remove because of unexpected gawk extensions:
#	awkpath clsflnam fnasgnm fnaryscl litoct tradanch
#
# Remove because of differences from gawk output:
#	argarray arrayparm convfmt defref fnarray fnarydel fsbs gsubasgn
#	hsprint nasty nfset noeffect nofmtch nonl noparms paramdup parseme
#	prmarscl prtoeval rand reindops resplit sclforin sclifin
#
# Remove because it hangs on Intel Pentium GNU/Linux with lcc:
#	clobber

basic:    anchgsub arrayref asgext back89 backgsub childin compare delarprm \
	  dynlj eofsplit fldchg fldchgnf fsrs fstabplus funstack getline \
	  getnr2tb getnr2tm gsubtest intest intprec longwrds math messages \
	  mmap8k msg negexp nfldstr nlfldsep nlinstr nors numsubstr ofmt \
	  ofmtbig ofmts pcntplus prdupval prmreuse prt1eval reparse rs \
	  rswhite splitargv splitdef splitvar splitwht sprintfc substr \
	  swaplns tweakfld zeroflag

# unix-tests: fflush getlnhd pid pipeio1 pipeio2 poundbang strftlng
#
# Remove because of gawk extensions:
#	pipeio1 pipeio2 poundbang strftlng
#
# Remove because of differences from gawk output:
#	fflush inftest pid

unix-tests: getlnhd

gawk.extensions: fieldwdth ignrcase posix manyfiles igncfs argtest \
		badargs strftime gensub gnureops reint nondec fsfwfs \
		lint procinfs

# extra:	regtest inftest
#
# Remove because of differences from gawk output:
#	inftest
extra:	regtest

poundbang::
	@cp $(AWK) /tmp/gawk && $(srcdir)/poundbang $(srcdir)/poundbang >_`basename $@`
	@rm -f /tmp/gawk
	$(CMP) $(srcdir)/poundbang.ok _`basename $@` && rm -f _`basename $@`

msg::
	#@echo 'Any output from "cmp" is bad news, except for fp differences'

swaplns::
	@$(AWK) -f $(srcdir)/swaplns.awk $(srcdir)/swaplns.in >_$@
	$(CMP) $(srcdir)/swaplns.ok _$@ && rm -f _$@

messages::
	@$(AWK) -f $(srcdir)/messages.awk >out2 2>out3
	$(CMP) $(srcdir)/out1.ok out1 && $(CMP) $(srcdir)/out2.ok out2 && $(CMP) $(srcdir)/out3.ok out3 && rm -f out1 out2 out3

argarray::
	@case $(srcdir) in \
	.)	: ;; \
	*)	cp $(srcdir)/argarray.in . ;; \
	esac
	@TEST=test echo just a test | $(AWK) -f $(srcdir)/argarray.awk ./argarray.in - >_$@
	$(CMP) $(srcdir)/argarray.ok _$@ && rm -f _$@

fstabplus::
	@echo '1		2' | $(AWK) -f $(srcdir)/fstabplus.awk >_$@
	$(CMP) $(srcdir)/fstabplus.ok _$@ && rm -f _$@

fsrs::
	@$(AWK) -f $(srcdir)/fsrs.awk $(srcdir)/fsrs.in >_$@
	$(CMP) $(srcdir)/fsrs.ok _$@ && rm -f _$@

igncfs::
	@$(AWK) -f $(srcdir)/igncfs.awk $(srcdir)/igncfs.in >_$@
	$(CMP) $(srcdir)/igncfs.ok _$@ && rm -f _$@

longwrds::
	@$(AWK) -f $(srcdir)/longwrds.awk $(srcdir)/manpage | LC_ALL=C sort >_$@
	$(CMP) $(srcdir)/longwrds.ok _$@ && rm -f _$@

fieldwdth::
	@echo '123456789' | $(AWK) -v FIELDWIDTHS="2 3 4" '{ print $$2}' >_$@
	$(CMP) $(srcdir)/fieldwdth.ok _$@ && rm -f _$@

ignrcase::
	@echo xYz | $(AWK) -v IGNORECASE=1 '{ sub(/y/, ""); print}' >_$@
	$(CMP) $(srcdir)/ignrcase.ok _$@ && rm -f _$@

regtest::
	@echo 'Some of the output from regtest is very system specific, do not'
	@echo 'be distressed if your output differs from that distributed.'
	@echo 'Manual inspection is called for.'
	AWK=`pwd`/$(AWK) $(srcdir)/regtest

posix::
	@echo '1:2,3 4' | $(AWK) -f $(srcdir)/posix.awk >_$@
	$(CMP) $(srcdir)/posix.ok _$@ && rm -f _$@

manyfiles::
	@rm -rf junk
	@mkdir junk
	@$(AWK) 'BEGIN { for (i = 1; i <= 300; i++) print i, i}' >_$@
	@$(AWK) -f $(srcdir)/manyfiles.awk _$@ _$@
	@echo "This number better be 1 ->" | tr -d '\012'
	@wc -l junk/* | $(AWK) '$$1 != 2' | wc -l
	@rm -rf junk _$@

compare::
	@$(AWK) -f $(srcdir)/compare.awk 0 1 $(srcdir)/compare.in >_$@
	$(CMP) $(srcdir)/compare.ok _$@ && rm -f _$@

arrayref::
	@$(AWK) -f $(srcdir)/arrayref.awk >_$@
	$(CMP) $(srcdir)/arrayref.ok _$@ && rm -f _$@

rs::
	@$(AWK) -v RS="" '{ print $$1, $$2}' $(srcdir)/rs.in >_$@
	$(CMP) $(srcdir)/rs.ok _$@ && rm -f _$@

fsbs::
	@$(AWK) -v FS='\' '{ print $$1, $$2 }' $(srcdir)/fsbs.in >_$@
	$(CMP) $(srcdir)/fsbs.ok _$@ && rm -f _$@

inftest::
	@echo This test is very machine specific...
	@$(AWK) -f $(srcdir)/inftest.awk >_$@
	$(CMP) $(srcdir)/inftest.ok _$@ && rm -f _$@

getline::
	@$(AWK) -f $(srcdir)/getline.awk $(srcdir)/getline.awk $(srcdir)/getline.awk >_$@
	$(CMP) $(srcdir)/getline.ok _$@ && rm -f _$@

rand::
	@$(AWK) -f $(srcdir)/rand.awk >_$@
	$(CMP) $(srcdir)/rand.ok _$@ && rm -f _$@

negexp::
	@$(AWK) 'BEGIN { a = -2; print 10^a }' >_$@
	$(CMP) $(srcdir)/negexp.ok _$@ && rm -f _$@

asgext::
	@$(AWK) -f $(srcdir)/asgext.awk $(srcdir)/asgext.in >_$@
	$(CMP) $(srcdir)/asgext.ok _$@ && rm -f _$@

anchgsub::
	@$(AWK) -f $(srcdir)/anchgsub.awk $(srcdir)/anchgsub.in >_$@
	$(CMP) $(srcdir)/anchgsub.ok _$@ && rm -f _$@

splitargv::
	@$(AWK) -f $(srcdir)/splitargv.awk $(srcdir)/splitargv.in >_$@
	$(CMP) $(srcdir)/splitargv.ok _$@ && rm -f _$@

awkpath::
	@AWKPATH="$(srcdir):$(srcdir)/lib" $(AWK) -f awkpath.awk >_$@
	$(CMP) $(srcdir)/awkpath.ok _$@ && rm -f _$@

nfset::
	@$(AWK) -f $(srcdir)/nfset.awk $(srcdir)/nfset.in >_$@
	$(CMP) $(srcdir)/nfset.ok _$@ && rm -f _$@

reparse::
	@$(AWK) -f $(srcdir)/reparse.awk $(srcdir)/reparse.in >_$@
	$(CMP) $(srcdir)/reparse.ok _$@ && rm -f _$@

argtest::
	@$(AWK) -f $(srcdir)/argtest.awk -x -y abc >_$@
	$(CMP) $(srcdir)/argtest.ok _$@ && rm -f _$@

badargs::
	@-$(AWK) -f 2>&1 | grep -v patchlevel >_$@
	$(CMP) $(srcdir)/badargs.ok _$@ && rm -f _$@

convfmt::
	@$(AWK) -f $(srcdir)/convfmt.awk >_$@
	$(CMP) $(srcdir)/convfmt.ok _$@ && rm -f _$@

arrayparm::
	@-AWKPATH=$(srcdir) $(AWK) -f arrayparm.awk >_$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/arrayparm.ok _$@ && rm -f _$@

paramdup::
	@-AWKPATH=$(srcdir) $(AWK) -f paramdup.awk >_$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/paramdup.ok _$@ && rm -f _$@

nonl::
	@-AWKPATH=$(srcdir) $(AWK) --lint -f nonl.awk /dev/null >_$@ 2>&1
	$(CMP) $(srcdir)/nonl.ok _$@ && rm -f _$@

defref::
	@-AWKPATH=$(srcdir) $(AWK) --lint -f defref.awk >_$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/defref.ok _$@ && rm -f _$@

nofmtch::
	@-AWKPATH=$(srcdir) $(AWK) --lint -f nofmtch.awk >_$@ 2>&1
	$(CMP) $(srcdir)/nofmtch.ok _$@ && rm -f _$@

strftime::
	: this test could fail on slow machines or on a second boundary,
	: so if it does, double check the actual results
	@LC_ALL=C; export LC_ALL; LANG=C; export LANG; \
	date | $(AWK) '{ $$3 = sprintf("%02d", $$3 + 0) ; \
	print > "strftime.ok" ; \
	print strftime() > "'_$@'" }'
	$(CMP) strftime.ok _$@ && rm -f _$@ strftime.ok || exit 0

litoct::
	@echo ab | $(AWK) --traditional -f $(srcdir)/litoct.awk >_$@
	$(CMP) $(srcdir)/litoct.ok _$@ && rm -f _$@

gensub::
	@$(AWK) -f $(srcdir)/gensub.awk $(srcdir)/gensub.in >_$@
	$(CMP) $(srcdir)/gensub.ok _$@ && rm -f _$@

resplit::
	@echo a:b:c d:e:f | $(AWK) '{ FS = ":"; $$0 = $$0; print $$2 }' > _$@
	$(CMP) $(srcdir)/resplit.ok _$@ && rm -f _$@

rswhite::
	@$(AWK) -f $(srcdir)/rswhite.awk $(srcdir)/rswhite.in > _$@
	$(CMP) $(srcdir)/rswhite.ok _$@ && rm -f _$@

prmarscl::
	@-AWKPATH=$(srcdir) $(AWK) -f prmarscl.awk > _$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/prmarscl.ok _$@ && rm -f _$@

sclforin::
	@-AWKPATH=$(srcdir) $(AWK) -f sclforin.awk > _$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/sclforin.ok _$@ && rm -f _$@

sclifin::
	@-AWKPATH=$(srcdir) $(AWK) -f sclifin.awk > _$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/sclifin.ok _$@ && rm -f _$@

intprec::
	@-$(AWK) -f $(srcdir)/intprec.awk > _$@ 2>&1
	$(CMP) $(srcdir)/intprec.ok _$@ && rm -f _$@

childin::
	@echo hi | $(AWK) 'BEGIN { "cat" | getline; print; close("cat") }' > _$@
	$(CMP) $(srcdir)/childin.ok _$@ && rm -f _$@

noeffect::
	@-AWKPATH=$(srcdir) $(AWK) --lint -f noeffect.awk > _$@ 2>&1
	$(CMP) $(srcdir)/noeffect.ok _$@ && rm -f _$@

numsubstr::
	@-AWKPATH=$(srcdir) $(AWK) -f numsubstr.awk $(srcdir)/numsubstr.in >_$@
	$(CMP) $(srcdir)/numsubstr.ok _$@ && rm -f _$@

gnureops::
	@$(AWK) -f $(srcdir)/gnureops.awk >_$@
	$(CMP) $(srcdir)/gnureops.ok _$@ && rm -f _$@

pcntplus::
	@$(AWK) -f $(srcdir)/pcntplus.awk >_$@
	$(CMP) $(srcdir)/pcntplus.ok _$@ && rm -f _$@

prmreuse::
	@$(AWK) -f $(srcdir)/prmreuse.awk >_$@
	$(CMP) $(srcdir)/prmreuse.ok _$@ && rm -f _$@

math::
	@$(AWK) -f $(srcdir)/math.awk >_$@
	$(CMP) $(srcdir)/math.ok _$@ && rm -f _$@

fflush::
	@$(srcdir)/fflush.sh >_$@
	$(CMP) $(srcdir)/fflush.ok _$@ && rm -f _$@

fldchg::
	@$(AWK) -f $(srcdir)/fldchg.awk $(srcdir)/fldchg.in >_$@
	$(CMP) $(srcdir)/fldchg.ok _$@ && rm -f _$@

fldchgnf::
	@$(AWK) -f $(srcdir)/fldchgnf.awk $(srcdir)/fldchgnf.in >_$@
	$(CMP) $(srcdir)/fldchgnf.ok _$@ && rm -f _$@

reindops::
	@$(AWK) -f $(srcdir)/reindops.awk $(srcdir)/reindops.in >_$@
	$(CMP) $(srcdir)/reindops.ok _$@ && rm -f _$@

sprintfc::
	@$(AWK) -f $(srcdir)/sprintfc.awk $(srcdir)/sprintfc.in >_$@
	$(CMP) $(srcdir)/sprintfc.ok _$@ && rm -f _$@

getlnhd::
	@$(AWK) -f $(srcdir)/getlnhd.awk >_$@
	$(CMP) $(srcdir)/getlnhd.ok _$@ && rm -f _$@

backgsub::
	@$(AWK) -f $(srcdir)/backgsub.awk $(srcdir)/backgsub.in >_$@
	$(CMP) $(srcdir)/backgsub.ok _$@ && rm -f _$@

tweakfld::
	@$(AWK) -f $(srcdir)/tweakfld.awk $(srcdir)/tweakfld.in >_$@
	@rm -f errors.cleanup
	$(CMP) $(srcdir)/tweakfld.ok _$@ && rm -f _$@

clsflnam::
	@$(AWK) -f $(srcdir)/clsflnam.awk $(srcdir)/clsflnam.in >_$@
	$(CMP) $(srcdir)/clsflnam.ok _$@ && rm -f _$@

mmap8k::
	@$(AWK) '{ print }' $(srcdir)/mmap8k.in >_$@
	$(CMP) $(srcdir)/mmap8k.in _$@ && rm -f _$@

fnarray::
	@-AWKPATH=$(srcdir) $(AWK) -f fnarray.awk >_$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/fnarray.ok _$@ && rm -f _$@

dynlj::
	@$(AWK) -f $(srcdir)/dynlj.awk >_$@
	$(CMP) $(srcdir)/dynlj.ok _$@ && rm -f _$@

substr::
	@$(AWK) -f $(srcdir)/substr.awk >_$@
	$(CMP) $(srcdir)/substr.ok _$@ && rm -f _$@

eofsplit::
	@$(AWK) -f $(srcdir)/eofsplit.awk >_$@
	$(CMP) $(srcdir)/eofsplit.ok _$@ && rm -f _$@

prt1eval::
	@$(AWK) -f $(srcdir)/prt1eval.awk >_$@
	$(CMP) $(srcdir)/prt1eval.ok _$@ && rm -f _$@

gsubasgn::
	@-AWKPATH=$(srcdir) $(AWK) -f gsubasgn.awk >_$@ 2>&1 || exit 0
	$(CMP) $(srcdir)/gsubasgn.ok _$@ && rm -f _$@

prtoeval::
	@$(AWK) -f $(srcdir)/prtoeval.awk >_$@
	$(CMP) $(srcdir)/prtoeval.ok _$@ && rm -f _$@

gsubtest::
	@$(AWK) -f $(srcdir)/gsubtest.awk >_$@
	$(CMP) $(srcdir)/gsubtest.ok _$@ && rm -f _$@

splitwht::
	@$(AWK) -f $(srcdir)/splitwht.awk >_$@
	$(CMP) $(srcdir)/splitwht.ok _$@ && rm -f _$@

back89::
	@$(AWK) '/a\8b/' $(srcdir)/back89.in >_$@
	$(CMP) $(srcdir)/back89.ok _$@ && rm -f _$@

tradanch::
	@$(AWK) --traditional -f $(srcdir)/tradanch.awk $(srcdir)/tradanch.in >_$@
	$(CMP) $(srcdir)/tradanch.ok _$@ && rm -f _$@

nlfldsep::
	@$(AWK) -f $(srcdir)/nlfldsep.awk $(srcdir)/nlfldsep.in > _$@
	$(CMP) $(srcdir)/nlfldsep.ok _$@ && rm -f _$@

splitvar::
	@$(AWK) -f $(srcdir)/splitvar.awk $(srcdir)/splitvar.in >_$@
	$(CMP) $(srcdir)/splitvar.ok _$@ && rm -f _$@

intest::
	@$(AWK) -f $(srcdir)/intest.awk >_$@
	$(CMP) $(srcdir)/intest.ok _$@ && rm -f _$@

# AIX /bin/sh exec's the last command in a list, therefore issue a ":"
# command so that pid.sh is fork'ed as a child before being exec'ed.
pid::

## original-awk 2010-05-23

=== debian/changelog ===
original-awk (2010-05-23-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Fri, 11 Jun 2010 18:09:12 +0200

original-awk (2010-02-08-1) unstable; urgency=low

  * New upstream release.
  * Switch to 3.0 (quilt) source format.
  * Pristine source, as dpkg-source handles flat tarballs.
  * Files ytab.c, ytab.h and proctab.c are no longer excluded from the
    orig tarball. Instead, they are removed in the clean target.
  * Use strip with appropriate options instead of "install -s"
    to make lintian happy.

 -- Santiago Vila <sanvila@debian.org>  Thu, 18 Feb 2010 23:42:00 +0100

original-awk (2009-11-26-1) unstable; urgency=low

  * New upstream release. Closes: #564892.

 -- Santiago Vila <sanvila@debian.org>  Tue, 12 Jan 2010 21:43:18 +0100

original-awk (2007-10-23-4) unstable; urgency=medium

  * Changed awk_getline to awkgetline, as there is already an "awkprintf".
  * Added missing rename in maketab.c. Closes: #555919.

 -- Santiago Vila <sanvila@debian.org>  Thu, 12 Nov 2009 17:42:36 +0100

original-awk (2007-10-23-3) unstable; urgency=medium

  * Renamed getline to awk_getline to make eglibc happy. Closes: #552859.

 -- Santiago Vila <sanvila@debian.org>  Mon, 09 Nov 2009 10:46:00 +0100

original-awk (2007-10-23-2) unstable; urgency=low

  * Changed URL from which the source was downloaded to match reality.
  * Do not ignore errors from make clean (lintian warning).

 -- Santiago Vila <sanvila@debian.org>  Sun, 30 Aug 2009 19:50:22 +0200

original-awk (2007-10-23-1) unstable; urgency=low

  * New upstream release. Closes: #491080.
  * Changed version string to match actual release date (20071023).

 -- Santiago Vila <sanvila@debian.org>  Sat, 26 Jul 2008 17:30:10 +0200

original-awk (2007-05-01-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Mon,  2 Jul 2007 18:33:46 +0200

original-awk (2005-04-24-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Fri, 18 Nov 2005 21:53:08 +0100

original-awk (2004-12-22-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Fri, 24 Dec 2004 20:19:48 +0100

original-awk (2004-02-07-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Fri, 25 Jun 2004 11:01:16 +0200

original-awk (2003-07-31-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Wed, 13 Aug 2003 11:28:16 +0200

original-awk (2003-03-14-1) unstable; urgency=low

  * New upstream release. awk will now do character comparisons and case
    conversions in national language, but "." will always be the decimal
    point separator on input and output regardless of national language.

 -- Santiago Vila <sanvila@debian.org>  Thu, 24 Apr 2003 23:09:04 +0200

original-awk (2002-06-28-1) unstable; urgency=low

  * New upstream release.
  * Standards-Version: 3.5.7.

 -- Santiago Vila <sanvila@debian.org>  Mon, 16 Sep 2002 20:38:02 +0200

original-awk (2002-02-10-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Sun,  3 Mar 2002 16:06:02 +0100

original-awk (2000-11-15-3) unstable; urgency=low

  * Added support for DEB_BUILD_OPTIONS.

 -- Santiago Vila <sanvila@debian.org>  Fri, 30 Nov 2001 17:29:12 +0100

original-awk (2000-11-15-2) unstable; urgency=low

  * Moved update-alternatives call from postrm to prerm as lintian suggests.

 -- Santiago Vila <sanvila@debian.org>  Fri,  7 Sep 2001 20:04:05 +0200

original-awk (2000-11-15-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@debian.org>  Wed, 10 Jan 2001 18:39:45 +0100

original-awk (2000-05-25-2) unstable; urgency=low

  * Build-Depends: bison.

 -- Santiago Vila <sanvila@debian.org>  Tue, 29 Aug 2000 18:52:52 +0200

original-awk (2000-05-25-1) frozen unstable; urgency=high

  * New upstream release, 8-bit clean (Closes: Bug#63836).
  * Standards-Version: 3.1.1.

 -- Santiago Vila <sanvila@ctv.es>  Sat, 27 May 2000 18:24:45 +0200

original-awk (1999-06-02-1) unstable; urgency=low

  * New upstream release. Should fix a problem with glibc 2.1.

 -- Santiago Vila <sanvila@ctv.es>  Thu,  3 Jun 1999 18:14:59 +0200

original-awk (1999-05-10-1) unstable; urgency=low

  * New upstream release.

 -- Santiago Vila <sanvila@ctv.es>  Wed, 26 May 1999 17:36:45 +0200

original-awk (1998-02-11-1) unstable; urgency=low

  * Initial release.

 -- Santiago Vila <sanvila@ctv.es>  Mon,  6 Apr 1998 20:03:23 +0200

=== debian/control ===
Source: original-awk
Section: interpreters
Priority: optional
Maintainer: Santiago Vila <sanvila@debian.org>
Standards-Version: 3.8.4
Build-Depends: bison

Package: original-awk
Architecture: any
Pre-Depends: ${shlibs:Depends}
Provides: awk
Description: The original awk described in "The AWK Programming Language"
 This is the version of awk described in "The AWK Programming Language",
 by Al Aho, Brian Kernighan, and Peter Weinberger
 (Addison-Wesley, 1988, ISBN 0-201-07981-X).

=== debian/rules ===
#!/usr/bin/make -f

package = original-awk
docdir = debian/tmp/usr/share/doc/$(package)

CC = gcc
CFLAGS = -g -Wall
STRIP = true

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  STRIP = strip --remove-section=.comment --remove-section=.note
endif

build:
	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS)"
	touch build

clean:
	rm -f build
	$(MAKE) clean
	rm -f `find . -name "*~"`
	rm -rf debian/tmp debian/files* core debian/substvars

binary-indep: build

binary-arch: build
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
	cd debian/tmp && install -d usr/bin usr/share/man/man1
	install -m 755 a.out debian/tmp/usr/bin/$(package)
	cd debian && install -m 755 postinst prerm tmp/DEBIAN
	install -m 644 debian/changelog $(docdir)/changelog.Debian
	install -m 644 awk.1 debian/tmp/usr/share/man/man1/$(package).1
	cp -p README FIXES debian/copyright $(docdir)
	cd $(docdir) && gzip -9 FIXES changelog.Debian
	ln -s FIXES.gz $(docdir)/changelog.gz
	$(STRIP) debian/tmp/usr/bin/*
	gzip -r9 debian/tmp/usr/share/man/man1
	dpkg-shlibdeps debian/tmp/usr/bin/*
	dpkg-gencontrol
	cd debian/tmp && \
		md5sum `find * -type f ! -regex "DEBIAN/.*"` > DEBIAN/md5sums
	chown -R 0:0 debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean

## original-awk 2011-05-06

=== debian/changelog ===
original-awk (2011-05-06-1) unstable; urgency=low

  * New upstream release. Closes: #627215.

 -- Santiago Vila <sanvila@debian.org>  Mon, 06 Jun 2011 13:15:27 +0200

## original-awk 2011-08-10

=== debian/changelog ===
original-awk (2011-08-10-2) unstable; urgency=low

  * Build with hardened flags.

 -- Santiago Vila <sanvila@debian.org>  Sun, 03 Jun 2012 17:00:18 +0200

original-awk (2011-08-10-1) unstable; urgency=low

  * New upstream release. Closes: #640653.
  * Added recommended targets build-arch and build-indep.

 -- Santiago Vila <sanvila@debian.org>  Thu, 22 Sep 2011 12:22:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 Build-Depends: bison
 
 Package: original-awk

=== debian/rules ===
--- 
+++ 
@@ -4,18 +4,17 @@
 docdir = debian/tmp/usr/share/doc/$(package)
 
 CC = gcc
-CFLAGS = -g -Wall
+CFLAGS := `dpkg-buildflags --get CFLAGS` -Wall
+LDFLAGS := `dpkg-buildflags --get LDFLAGS`
+CPPFLAGS := `dpkg-buildflags --get CPPFLAGS`
 STRIP = true
 
-ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-  CFLAGS += -O2
-endif
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
   STRIP = strip --remove-section=.comment --remove-section=.note
 endif
 
 build:
-	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS)"
+	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS) $(CPPFLAGS)" ALLOC="$(LDFLAGS)"
 	touch build
 
 clean:
@@ -49,4 +48,8 @@
 
 binary: binary-indep binary-arch
 
-.PHONY: binary binary-arch binary-indep clean
+build-arch: build
+
+build-indep: build
+
+.PHONY: binary binary-arch binary-indep build-arch build-indep clean

## original-awk 2012-12-20

=== debian/changelog ===
original-awk (2012-12-20-6) unstable; urgency=medium

  * Rename all patches to end with .patch.
  * Standards-Version: 3.9.8 (no special changes for this).

 -- Santiago Vila <sanvila@debian.org>  Sun, 08 Jan 2017 18:47:44 +0100

original-awk (2012-12-20-5) unstable; urgency=medium

  * Switch to dh. This should make the package reproducible again.
  * Pass both CFLAGS and CPPFLAGS to makefile, and modify makefile
    so that those variables are used when they have to be used.
    This way we can still use make's implicit .c to .o rule.

 -- Santiago Vila <sanvila@debian.org>  Sun, 11 Oct 2015 12:29:16 +0200

original-awk (2012-12-20-4) unstable; urgency=medium

  * Multi-Arch: foreign. Closes: #795115.

 -- Santiago Vila <sanvila@debian.org>  Tue, 11 Aug 2015 17:48:00 +0200

original-awk (2012-12-20-3) unstable; urgency=low

  * Use gzip -n to make the build reproducible. Closes: #778203.
  * Fix mtimes before building binary package as well.

 -- Santiago Vila <sanvila@debian.org>  Fri, 15 May 2015 14:00:42 +0200

original-awk (2012-12-20-2) unstable; urgency=medium

  * Added descriptions to debian/patches/*.
  * Added Homepage field.
  * Added hardening=+all.

 -- Santiago Vila <sanvila@debian.org>  Thu, 09 Oct 2014 12:42:52 +0200

original-awk (2012-12-20-1) unstable; urgency=low

  * New upstream release.
  * Pass YACC="bison -d -y" to upstream makefile.

 -- Santiago Vila <sanvila@debian.org>  Sat, 12 Oct 2013 18:46:00 +0200

=== debian/control ===
Source: original-awk
Section: interpreters
Priority: optional
Maintainer: Santiago Vila <sanvila@debian.org>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), bison
Homepage: http://www.cs.princeton.edu/~bwk/btl.mirror/

Package: original-awk
Architecture: any
Pre-Depends: ${shlibs:Depends}
Depends: ${misc:Depends}
Provides: awk
Multi-Arch: foreign
Description: The original awk described in "The AWK Programming Language"
 This is the version of awk described in "The AWK Programming Language",
 by Al Aho, Brian Kernighan, and Peter Weinberger
 (Addison-Wesley, 1988, ISBN 0-201-07981-X).

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

package = original-awk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CC = gcc
CFLAGS := `dpkg-buildflags --get CFLAGS` -Wall
LDFLAGS := `dpkg-buildflags --get LDFLAGS`
CPPFLAGS := `dpkg-buildflags --get CPPFLAGS`

override_dh_auto_build:
	dh_auto_build -- CC="$(CC)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ALLOC="$(LDFLAGS)" YACC="bison -d -y"

override_dh_auto_install:
	install -m 755 a.out debian/$(package)/usr/bin/$(package)
	install -m 644 awk.1 debian/$(package)/usr/share/man/man1/$(package).1

## original-awk 2018-08-27

=== debian/changelog ===
original-awk (2018-08-27-1) unstable; urgency=medium

  * New upstream release, now hosted on github. Closes: #976161.
  * Upgrade build-dependency on debhelper.
  * Rules-Requires-Root: no.

 -- Santiago Vila <sanvila@debian.org>  Mon, 21 Dec 2020 22:24:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: interpreters
 Priority: optional
 Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), bison
-Homepage: http://www.cs.princeton.edu/~bwk/btl.mirror/
+Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), bison
+Homepage: https://github.com/onetrueawk/awk
+Rules-Requires-Root: no
 
 Package: original-awk
 Architecture: any

## original-awk 2022-09-12

=== debian/changelog ===
original-awk (2022-09-12-1) unstable; urgency=medium

  * Upstream does not (usually) make releases, and there are quite a
    number of memory handling fixes by Miguel Piñeiro Jr.
    Update the Debian package accordingly.

 -- Santiago Vila <sanvila@debian.org>  Sun, 05 Feb 2023 18:35:00 +0100

original-awk (2022-01-22-1) unstable; urgency=medium

  * New upstream release. Closes: #1019400.
  * Cross-building is now supported. Closes: #923023.
    Thanks to Helmut Grohne.
  * Set upstream metadata fields Bug-Database, Bug-Submit and Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Add Vcs-Git and Vcs-Browser fields.

 -- Santiago Vila <sanvila@debian.org>  Thu, 22 Dec 2022 16:35:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: interpreters
 Priority: optional
 Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13), bison
 Homepage: https://github.com/onetrueawk/awk
+Vcs-Git: https://salsa.debian.org/sanvila/original-awk.git
+Vcs-Browser: https://salsa.debian.org/sanvila/original-awk
 Rules-Requires-Root: no
 
 Package: original-awk

## original-awk 2023-11-27

=== debian/changelog ===
original-awk (2023-11-27-1) unstable; urgency=medium

  * New upstream version.

 -- Santiago Vila <sanvila@debian.org>  Fri, 15 Dec 2023 23:20:00 +0100

original-awk (2023-10-30-1) unstable; urgency=medium

  * This version handles UTF-8 and comma-separated values (CSV) input.
  * Provide nawk, using alternatives. Closes: #868979.
  * Convert copyright file to machine-readable format.

 -- Santiago Vila <sanvila@debian.org>  Fri, 10 Nov 2023 15:30:00 +0100

=== debian/control ===
--- 
+++ 
@@ -17,5 +17,5 @@
 Multi-Arch: foreign
 Description: The original awk described in "The AWK Programming Language"
  This is the version of awk described in "The AWK Programming Language",
- by Al Aho, Brian Kernighan, and Peter Weinberger
- (Addison-Wesley, 1988, ISBN 0-201-07981-X).
+ Second Edition, by Al Aho, Brian Kernighan, and Peter Weinberger
+ (Addison-Wesley, 2024, ISBN-13 978-0138269722, ISBN-10 0138269726).

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk

%:
	dh $@

package = original-awk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CFLAGS := `dpkg-buildflags --get CFLAGS` -Wall
LDFLAGS := `dpkg-buildflags --get LDFLAGS`
CPPFLAGS := `dpkg-buildflags --get CPPFLAGS`

override_dh_auto_build:
	dh_auto_build -- CC="$(CC)" HOSTCC="$(CC_FOR_BUILD)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ALLOC="$(LDFLAGS)"

override_dh_auto_install:
	install -m 755 a.out debian/$(package)/usr/bin/$(package)
	install -m 644 awk.1 debian/$(package)/usr/share/man/man1/$(package).1

## original-awk 2024-06-23

=== debian/changelog ===
original-awk (2024-06-23-1) unstable; urgency=medium

  * New upstream version.

 -- Santiago Vila <sanvila@debian.org>  Wed, 26 Jun 2024 15:10:00 +0200

## original-awk 2025-01-16

=== debian/changelog ===
original-awk (2025-01-16-1) unstable; urgency=medium

  * New upstream version.
  * Add a preliminary debian/salsa-ci.yml.
  * Add lintian override for testdir/t.a.
  * Do not trim Debian changelog.
  * Update Standards-Version.

 -- Santiago Vila <sanvila@debian.org>  Wed, 22 Jan 2025 20:10:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13), bison
 Homepage: https://github.com/onetrueawk/awk
 Vcs-Git: https://salsa.debian.org/sanvila/original-awk.git

=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,10 @@
 override_dh_auto_install:
 	install -m 755 a.out debian/$(package)/usr/bin/$(package)
 	install -m 644 awk.1 debian/$(package)/usr/share/man/man1/$(package).1
+
+override_dh_auto_test:
+	@echo blhc: ignore-line-regexp: compiling time.c
+	dh_auto_test
+
+override_dh_installchangelogs:
+	dh_installchangelogs --no-trim

## original-awk 2025-08-04

=== debian/changelog ===
original-awk (2025-08-04-1) unstable; urgency=medium

  * New upstream version.

 -- Santiago Vila <sanvila@debian.org>  Fri, 29 Aug 2025 18:20:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Santiago Vila <sanvila@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13), bison
 Homepage: https://github.com/onetrueawk/awk
 Vcs-Git: https://salsa.debian.org/sanvila/original-awk.git
